{% extends "dashboard/base.html" %}
{% load general_tags %}
{% load i18n %}
{% load bootstrap %}
{% load static %}


{% block stylesheet %}

<link href="{% static 'css/plugins/sweetalert/sweetalert.css' %}" rel="stylesheet">
<link href="{% static 'css/animate.css' %}" rel="stylesheet">
<link href="{% static 'css/style.css' %}" rel="stylesheet">
<link href="{% static 'css/timeline.css' %}" rel="stylesheet">
<link href="{% static 'css/plugins/bootstrap-tagsinput/bootstrap-tagsinput.css' %}" rel="stylesheet">
<link href="{% static 'css/plugins/select2/select2.min.css' %}" rel="stylesheet">
<link href="{% static 'css/plugins/chosen/bootstrap-chosen.css' %}" rel="stylesheet">

{% endblock stylesheet  %}

{% block breadcrumb %}

<div class="row wrapper border-bottom white-bg page-heading">
    <div class="col-lg-10">
        <h2>{% trans "Crear Rubrica-ABET" %}</h2>
        <ol class="breadcrumb">
            <li>
                <a href="{% url 'dashboard' %}">{% trans "Dashboard" %}</a>
            </li>
            <li>
                <a href="{% url 'dashboard' %}">{% trans "Planificación" %}</a>
            </li>
            <li class="active">
                <strong>{% trans "Crear Rubrica-ABET" %}</strong>
            </li>
        </ol>
    </div>
    <div class="col-lg-2">

    </div>
</div>

{% endblock breadcrumb %}

{% block content %}

<div class="row">
    <div class="col-lg-12">
        <div class="ibox">
            <div class="ibox-title blue-bg">
                <h5 style="font-size:20px;" id="titulo_rubrica">Rubrica: {{rubric.name}}</h5>
                <div class="ibox-tools">
                    <a class="collapse-link">
                        <i class="fa fa-chevron-up" style="color:white"></i>
                    </a>
                </div>
            </div>
            <div class="ibox-content">
                <div class="row">
                    <div class="col-md-4">
                        <label class="control-label" for="id_rubric_course">Asignatura</label>
                        <h5 id="id_rubric_course"> {{rubric.get_course}} </h5>
                    </div>
                    <div class="col-md-4">
                        <label class="control-label" for="id_rubric_carreer">Carrera:</label>
                        <h5 id="id_rubric_carreer"> {{rubric.carreer}}</h5>
                    </div>
                    <div class="col-md-4">
                        <label class="control-label" for="id_rubric_date">Ultima Edicion: </label>
                        <h5 id="id_rubric_date"> {{rubric.date}}</h5>
                    </div>
                </div>
                <hr>
                <div class="row outcomes animated fadeInRight">
                    <div class="col-md-2" >{{form.nota_suf|bootstrap}}</div>
                    <div class="col-md-2" >{{form.nota_enpr|bootstrap}}</div>
                    <div class="col-md-2" >{{form.nota_inci|bootstrap}}</div>
                    <div class="col-md-2" >
                        <button class="btn btn-sm btn-rounded btn-primary" disabled id="validate_grades" style="margin-top:25px"><i class="fa fa-check"></i></button>
                    </div>
                    <div class="col-md-4"></div>
                    <div class="form-group col-md-8">
                        {{form.outcome|bootstrap}}
                    </div>
                    <div class="col-md-4" id="button_outcome">  
                        <button type="button" id="add_outcome" class="btn btn-block btn-primary" data-rubricpk={{rubric.pk}} style="margin-top: 22px">Incluir Outcome</button>
                    </div>
                </div>
                <hr>
                <div class="row outcomes">
                    <div class="ibox">
                        <div class="ibox-title bg-info">
                            <h5 style="font-size:20px;">Outcomes a evaluar</h5>
                            <div class="ibox-tools">
                                <a class="collapse-link">
                                    <i class="fa fa-chevron-up" style="color:white"></i>
                                </a>
                            </div>
                        </div>
                        <div class="ibox-content" id="outcome_content">
                            {% for outcome in rubric.outcomes.all %}
                            <div class="ibox animated fadeInRight" id="outcome_info_{{outcome.pk}}">
                                <div class="ibox-title bg-warning">
                                    <h5 style="font-size:20px;">{{outcome}}</h5>
                                    <div class="ibox-tools">
                                        <button class="btn btn-sm btn-danger remove_outcome" id="remove_outcome" data-outcomepk={{outcome.pk}}>
                                            <i class="fa fa-times" style="color:white"></i>
                                        </button>
                                    </div>
                                </div>
                                <div class="ibox-content">
                                    <table class="table">
                                        <thead>
                                        <tr>
                                            <th>Descripcion Criterio</th>
                                            <th>Suficiente</th>
                                            <th>En Proceso</th>
                                            <th>Inscipiente</th>
                                        </tr>
                                        </thead>
                                        <tbody id="content_table_criteria_{{outcome.pk}}">
                                            {% for criteria in outcome.criteria_set.all %}
                                            <tr id="row_criteria_{{criteria.pk}}">
                                                <td>{{criteria.description}}</td>
                                                <td>{{criteria.criteria_info.suficient}}</td>
                                                <td>{{criteria.criteria_info.inprocess}}</td>
                                                <td>{{criteria.criteria_info.inscipient}}</td>
                                            </tr>
                                            {% endfor %}
                                        </tbody>
                                    </table>
                                </div>
                            </div>                        
                            {% endfor %}
                        </div>
                    </div>
                </div>
                <div class="row outcomes">
                    <div class="col-md-4 pull-right">
                        <a href="{% url 'planning_abet_rubric_list' %}" type="button" style="margin-top: 24px" class="btn btn-block btn-primary">
                            Guardar
                            <i class="fa fa-check" style="color:white"></i>
                        </a>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>


{% endblock content %}


{% block javascript %}
<script src="{% static 'js/plugins/select2/select2.full.min.js' %}"></script>
<script src="{% static 'js/plugins/chosen/chosen.jquery.js' %}"></script>

<script>
    
$(document).on("click",".remove_outcome",function(e){
    var outcome_pk = $(this).data('outcomepk');
    var rubric_pk = $("#add_outcome").data('rubricpk')  
    var button = $(this);
    data ={
        outcome_pk: outcome_pk,
        rubric_pk: rubric_pk,
        carreer_pk: '{{carreer.pk}}',
        csrfmiddlewaretoken: '{{ csrf_token }}',
          };

    $.ajax({
        type: "post",
        dataType: "json",
        url: "{% url 'planning_rubric_outcome_remove' %}",
        data: data ,

        success: function(data){
            $("#id_outcome").html(data.outcomes_opt);
            button.parent().parent().parent().remove();
        },
    });
});

$(document).ready(function(){
    data={
    
        carreer_pk: '{{carreer.pk}}',
        rubric:'{{rubric.pk}}',
        csrfmiddlewaretoken: '{{ csrf_token }}',

    };
    $.ajax({
        type: "post",
        dataType: "json",
        url: "{% url 'planning_abet_rubric_opt' %}",
        data: data,
        success: function(data){
            $("#id_outcome").html(data.outcomes);
        },
        error: function(data){
            alert("problema con los datos");
        },
    });
    $("#id_nota_suf").val("{{rubric.nota_suf}}");
    $("#id_nota_inci").val("{{rubric.nota_inci}}");
    $("#id_nota_enpr").val("{{rubric.nota_enpr}}");

    $("#id_carreer").on("change", function(){
        carreer_pk = $("#id_carreer").val();
        var data = {

            carreer_pk : carreer_pk, 
            csrfmiddlewaretoken: '{{ csrf_token }}'
            
            };
            
        $.ajax({
            type: "post",
            dataType: "json",
            url: "{% url 'get_carreer_subject' %}",
            data: data,

            success: function(data){
                $("#id_subject").html(data.subjects)
            },

        });
    });

    $("#accept_name").click(function(){
        $("#form_create").addClass("animated fadeOutLeft");
        $("#form_create").hide();
        
        var data={
            
            nombre: $("#id_name").val(),
            subject_pk: $("#id_subject").val(),
            nota_suf: $("#id_nota_suf").val(),
            nota_enpr: $("#id_nota_enpr").val(),
            nota_inci: $("#id_nota_inci").val(),
            csrfmiddlewaretoken: '{{ csrf_token }}',
            
        };

        var data2={

            carreer_pk: $("#id_carreer").val(),
            csrfmiddlewaretoken: '{{ csrf_token }}',

        }
        $(".outcomes").addClass("animated fadeInRight");
        $(".outcomes").show();
        $.ajax({
            type: "post",
            dataType: "json",
            url: "{% url 'planning_abet_rubric_create' %}",
            data: data,

            success: function(data){
                $("#titulo_rubrica").html(data.titulo);
                $("#add_outcome").attr('data-rubricpk',data.rubricpk)
            },

            error: function(data){
                alert(data.titulo);
            },
        });
        $.ajax({
            type: "post",
            dataType: "json",
            url: "{% url 'get_carreer_outcomes' %}",
            data: data2,

            success: function(data){
                $("#id_outcome").html(data.outcomes);
            },

            error: function(data){
                alert("problema con los datos");
            },
        });
        });

    $("#id_outcome").select2({ width: '100%' });

    $("#add_outcome").click(function(){
        var outcome_pks = $("#id_outcome").val();
        var rubric_pk = $(this).data('rubricpk')
        data = {
            rubric_pk: rubric_pk,
            "keys[]": outcome_pks,
            carreer_pk: "{{carreer.pk}}",
            csrfmiddlewaretoken: '{{ csrf_token }}',
        };
        $.ajax({
            type: "post",
            dataType: "json",
            url: "{% url 'planning_abet_rubric_add_outcomes' %}",
            data: data,

            success: function(data){
                $("#outcome_content").append(data.outcomes);
                $("#id_outcome").select2("val","");
                $("#id_outcome").html(data.outcomes_opt);
            },
        });
    });
    $("#id_nota_suf").on("change",function(){
        $("#validate_grades").prop("disabled", false);
    });
    $("#id_nota_enpr").on("change",function(){
        $("#validate_grades").prop("disabled", false);
    });
    $("#id_nota_inci").on("change",function(){
        $("#validate_grades").prop("disabled", false);
    });
    $("#validate_grades").click(function(){
        var nota_suf = parseInt($("#id_nota_suf").val(),10);
        var nota_enpr = parseInt($("#id_nota_enpr").val(),10);
        var nota_inci = parseInt($("#id_nota_inci").val(),10);

        if (nota_suf>nota_enpr && nota_enpr>nota_inci && nota_suf<=7 && nota_inci>=1){
            data= {
                rubric_pk: '{{rubric.pk}}',
                nota_suf: $("#id_nota_suf").val(),
                nota_enpr: $("#id_nota_enpr").val(),
                nota_inci: $("#id_nota_inci").val(),
                csrfmiddlewaretoken: '{{ csrf_token }}',
            };
            $.ajax({
                type: "post",
                dataType: "json",
                url: "{% url 'planning_set_grades' %}",
                data: data,

                success: function(data){
                    $("#validate_grades").prop("disabled", true);

                },
            });

        } else {
            swal({
                title: "Notas incorrectas",
                text: "Las notas deben ser crecientes de incipiente a suficiente. (nota máxima 7)",
                type: "error",
                confirmButtonColor: "#DD6B55",
                confirmButtonText: "Entendido.",
                closeOnConfirm: false
            });
        };
    });
});

</script>
{% endblock javascript %}

